ALTER TABLE person
    ADD COLUMN managed_mail_domain_target TEXT;

GRANT UPDATE (managed_mail_domain_target) ON person TO selfservice_updater;

CREATE OR REPLACE VIEW apps.managed_mail_domain_v3 AS
WITH all_aliases AS (
-- aliases from public.mail_alias
    SELECT
        alias,
        addresses AS target,
        comment,
        1 AS priority
    FROM
        public.mail_alias
-- aliases generated from public.person
    UNION
    SELECT
        person.crsid AS alias,
        COALESCE(person.managed_mail_domain_target, person.email_address) AS addresses,
        'autogenerated from db'::character varying AS comment,
        2 AS priority
    FROM
        person
        JOIN _physical_status_v3 ON person.id = _physical_status_v3.person_id
    WHERE (_physical_status_v3.status_id::text = 'Current'::text
        OR _physical_status_v3.status_id::text = 'Past'::text)
    AND person.crsid IS NOT NULL
    AND person.email_address IS NOT NULL
    AND btrim(COALESCE(person.managed_mail_domain_target, person.email_address)) <> person.crsid || '@ch.cam.ac.uk' -- no mail loops
    AND NOT person.managed_mail_domain_optout
-- room aliases
    UNION
    SELECT
        a.email_local_part AS alias,
        array_to_string(a.array_addresses, ','::text) AS addresses,
        'room alias from db'::character varying AS comment,
        3 AS priority
    FROM (
        SELECT
    	room.email_local_part,
    	ARRAY (
    	    SELECT
    		btrim(p.email_address::text) AS btrim
    	FROM
    	    person p
    	    JOIN mm_person_room mm ON p.id = mm.person_id
    	    JOIN room r2 ON mm.room_id = r2.id
    	    LEFT JOIN _physical_status_v3 USING (person_id)
    	WHERE
    	    r2.id = room.id
    	    AND p.email_address IS NOT NULL
    	    AND p.email_address::text ~~ '%@%'::text
    	    AND _physical_status_v3.status_id::text = 'Current'::text) AS array_addresses
        FROM
    	room) a
        WHERE
    	a.array_addresses <> '{}'::text[]
-- cabinet aliases
    UNION
    SELECT
        a.alias,
        a.target,
        a.comment,
        4 AS priority
    FROM (
        SELECT
            cabinet.email_local_part AS alias,
            array_to_string(ARRAY (
                    SELECT
                        room.email_local_part::text || '@ch.cam.ac.uk'::text FROM room
                        JOIN mm_cabinet_serves_room ON room.id = mm_cabinet_serves_room.room_id
                    WHERE
                        mm_cabinet_serves_room.cabinet_id = cabinet.id), ','::text) AS target,
        'Cabinet alias from database'::text AS comment
    FROM
        cabinet) a
    WHERE
        a.target IS NOT NULL
        AND a.target <> ''::text
-- group rep aliases
    UNION
    SELECT
        a.alias,
        array_to_string(a.array_addresses, ','::text) AS target,
        'Group computer rep alias'::character varying AS comment,
        5 AS priority
    FROM (
        SELECT
            research_group.id,
            research_group.name,
            'comp-rep-'::text || regexp_replace(lower(research_group.name::text), '[^a-z]+'::text, ''::text, 'g'::text) AS alias,
            ARRAY (
                SELECT
                    btrim(p.email_address::text) AS btrim
                FROM
                    person p
                LEFT JOIN _physical_status_v3 ps ON p.id = ps.person_id
                JOIN mm_research_group_computer_rep mm ON p.id = mm.computer_rep_id
                JOIN research_group r2 ON mm.research_group_id = r2.id
            WHERE
                ps.status_id::text = 'Current'::text
                AND p.email_address::text ~~ '%@%'::text
                AND p.email_address IS NOT NULL
                AND r2.id = research_group.id) AS array_addresses
        FROM
            research_group) a
    WHERE
        a.array_addresses <> '{}'::text[])
SELECT DISTINCT ON (alias)
    alias,
    target,
    comment
FROM
    all_aliases
ORDER BY
    alias,
    priority;

DROP VIEW selfservice."40_Selfservice/Database_Selfservice";

CREATE VIEW selfservice."40_Selfservice/Database_Selfservice"
 AS
 SELECT DISTINCT person.id,
    title_hid.abbrev_title AS ro_title,
    person.first_names AS ro_first_names,
    person.surname AS ro_surname,
    person.known_as,
    person.name_suffix AS name_suffix_eg_frs,
    gender_hid.gender_hid AS ro_gender,
    person.previous_surname AS ro_previous_name,
    nationality_string.ro_nationality,
    person.email_address,
    person.hide_email AS hide_email_from_dept_websites,
    ARRAY( SELECT mm.room_id
           FROM mm_person_room mm
          WHERE mm.person_id = person.id) AS room_id,
    ARRAY( SELECT mm.dept_telephone_number_id
           FROM mm_person_dept_telephone_number mm
          WHERE mm.person_id = person.id) AS dept_telephone_number_id,
    cambridge_college_hid.cambridge_college_hid AS ro_cambridge_college,
    person.cambridge_address::text AS home_address,
    person.cambridge_phone_number AS home_phone_number,
    person.emergency_contact::text AS emergency_contact,
    research_groups_string.ro_research_group,
    post_category_hid.post_category_hid::character varying AS ro_post_category,
    supervisor_hid.supervisor_hid::character varying AS ro_supervisor,
    person.arrival_date AS ro_arrival_date,
    _latest_role_v12.funding_end_date AS ro_funding_end_date,
    COALESCE(_latest_role_v12.intended_end_date, _latest_role_v12.end_date) AS ro_expected_leaving_date,
    person.crsid AS ro_crsid,
    person.managed_mail_domain_target::varchar AS alternative_email_target_for_chemistry_mail_domain,
    person.managed_mail_domain_optout AS opt_out_of_chemistry_mail_domain,
    person.do_not_show_on_website AS hide_from_website,
    person.hide_photo_from_website,
    user_account.chemnet_token AS ro_chemnet_token,
    false AS create_new_token
   FROM person
     LEFT JOIN _latest_role_v12 ON person.id = _latest_role_v12.person_id
     LEFT JOIN user_account ON user_account.username::text = person.crsid::text
     LEFT JOIN cambridge_college_hid USING (cambridge_college_id)
     LEFT JOIN supervisor_hid USING (supervisor_id)
     LEFT JOIN gender_hid USING (gender_id)
     LEFT JOIN title_hid USING (title_id)
     LEFT JOIN post_category_hid USING (post_category_id)
     LEFT JOIN mm_person_research_group ON mm_person_research_group.person_id = person.id
     LEFT JOIN research_group ON mm_person_research_group.research_group_id = research_group.id
     LEFT JOIN ( SELECT person_1.id AS person_id,
            string_agg(nationality.nationality::text, ', '::text)::character varying AS ro_nationality
           FROM person person_1
             LEFT JOIN mm_person_nationality ON mm_person_nationality.person_id = person_1.id
             LEFT JOIN nationality ON mm_person_nationality.nationality_id = nationality.id
          GROUP BY person_1.id) nationality_string ON nationality_string.person_id = person.id
     LEFT JOIN ( SELECT person_1.id AS person_id,
            string_agg(research_group_1.name::text, ', '::text)::character varying AS ro_research_group
           FROM person person_1
             LEFT JOIN mm_person_research_group mm_person_research_group_1 ON mm_person_research_group_1.person_id = person_1.id
             LEFT JOIN research_group research_group_1 ON mm_person_research_group_1.research_group_id = research_group_1.id
          GROUP BY person_1.id) research_groups_string ON research_groups_string.person_id = person.id
  WHERE person.crsid::name = "current_user"() AND person.ban_from_self_service <> true
  GROUP BY person.id, title_hid.abbrev_title, gender_hid.gender_hid, cambridge_college_hid.cambridge_college_hid, post_category_hid.post_category_hid, supervisor_hid.supervisor_hid, _latest_role_v12.funding_end_date, _latest_role_v12.intended_end_date, _latest_role_v12.end_date, user_account.chemnet_token, nationality_string.ro_nationality, research_groups_string.ro_research_group;

ALTER TABLE selfservice."40_Selfservice/Database_Selfservice"
    OWNER TO dev;

GRANT ALL ON TABLE selfservice."40_Selfservice/Database_Selfservice" TO dev;
GRANT SELECT, UPDATE ON TABLE selfservice."40_Selfservice/Database_Selfservice" TO PUBLIC;

CREATE OR REPLACE FUNCTION selfservice.selfservice_upd()
    RETURNS trigger
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE NOT LEAKPROOF SECURITY DEFINER
    SET search_path=public, pg_temp
AS $BODY$
DECLARE
    _crsid varchar;
BEGIN
    UPDATE person SET
            known_as = NEW.known_as,
            name_suffix = NEW.name_suffix_eg_frs,
            email_address = NEW.email_address,
            hide_email = NEW.hide_email_from_dept_websites,
            cambridge_address = NEW.home_address::varchar(500),
            cambridge_phone_number = NEW.home_phone_number,
            emergency_contact = NEW.emergency_contact::varchar(500),
            managed_mail_domain_target = NEW.alternative_email_target_for_chemistry_mail_domain,
            managed_mail_domain_optout = NEW.opt_out_of_chemistry_mail_domain,
            do_not_show_on_website = NEW.hide_from_website,
            hide_photo_from_website = NEW.hide_photo_from_website
    WHERE id = OLD.id;
-- do mm updates
    PERFORM fn_mm_array_update(NEW.dept_telephone_number_id,
                                'mm_person_dept_telephone_number'::varchar,
                                'person_id'::varchar,
                                'dept_telephone_number_id'::varchar,
                                OLD.id);
    PERFORM fn_mm_array_update(NEW.room_id,
                                'mm_person_room'::varchar,
                                'person_id'::varchar,
                                'room_id'::varchar,
                                OLD.id);
-- generate token if needed
    IF NEW.create_new_token THEN
        UPDATE user_account SET chemnet_token=random_string_lower(16) WHERE person_id = OLD.id;
        IF NOT FOUND THEN
            -- Can only add people with CRSIDs
            SELECT crsid FROM person WHERE person.id=v.id INTO _crsid;
            IF FOUND THEN 
                INSERT INTO user_account (username, person_id, chemnet_token) VALUES (_crsid, OLD.id, random_string_lower(16));
            END IF;
        END IF;
    END IF;
RETURN NEW;
END
$BODY$;

CREATE TRIGGER selfservice_trig
    INSTEAD OF UPDATE 
    ON selfservice."40_Selfservice/Database_Selfservice"
    FOR EACH ROW
    EXECUTE FUNCTION selfservice.selfservice_upd();
